/////////////////////////////////////////////////////////////////////////////////
//
// B2API.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: B2API.h,v $
 * Revision 1.4  2000/07/13 15:12:23  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 * Revision 1.3  2000/07/07 14:11:54  syou
 * - ؂Bmultipartȃ[؂ł܂BAʂ{ɕ\
 *   ̂Łccǂł傤H  Ƃ́A؃xwł悤ɂA
 *   ̑OɕȂẮB
 *   CBkMessage::ExploreItemTree̋@\͂܂ӖȂH
 *   CBkMailPGPn̎̂ł͂ȂāA͂class CBkPGPMailh
 *   čׂB
 *   class count_ptrǉČڕGBꂪƂĂȂ܂B
 *   قƂǐŁAclass CEventDataAclass CSignatureDataȂǂǉB
 *
 * Revision 1.1  2000/07/05 23:50:31  murayama-s
 * - ؂̎dg݂͂BƂ͏ڍׂȎdllȂ
 *    ȂBclass CSignatureDataǉB܂l̗]n傫
 *    classB
 *
 * Revision 1.1  2000/06/22 14:34:53  syou
 * no message
 *
 */

#pragma once


#define CB2API_DEFINED_BY_YUGA


#include <windows.h>
#include "../BeckyAPI.h"
#include "../BkCommon.h"


/////////////////////////////////////////////////////////////////////////////////
//
class CB2API
{
public:
    ~CB2API()
    {   _instance = NULL;   }

    static CB2API* Instance()
    {
        if (_instance == NULL) {
            _instance = new CB2API();
        }

        if (_instance->m_hInstBecky == NULL) {
            delete _instance;
            return NULL;
        }

        return _instance;
    }

    LPCTSTR (WINAPI* GetVersion)();
    void    (WINAPI* Command)(HWND hWnd, LPCTSTR lpCmd);
    BOOL    (WINAPI* GetWindowHandles)(HWND* lphMain, HWND* lphTree, HWND* lphList, HWND* lphView);
    UINT    (WINAPI* RegisterCommand)(LPCTSTR lpszComment, int nTarget, void (CALLBACK* lpCallback)(HWND, LPARAM));
    UINT    (WINAPI* RegisterUICallback)(UINT nID, UINT (CALLBACK* lpCallback)(HWND, LPARAM));
    LPCTSTR (WINAPI* GetDataFolder)();
    LPCTSTR (WINAPI* GetTempFolder)();
    LPCTSTR (WINAPI* GetTempFileName)(LPCTSTR lpType);
    LPCTSTR (WINAPI* GetCurrentMailBox)();
    void    (WINAPI* SetCurrentMailBox)(LPCTSTR lpMailBox);
    LPCTSTR (WINAPI* GetCurrentFolder)();
    void    (WINAPI* SetCurrentFolder)(LPCTSTR lpFolderID);
    LPCTSTR (WINAPI* GetFolderDisplayName)(LPCSTR lpFolderID);
    void    (WINAPI* SetMessageText)(HWND hWnd, LPCSTR lpszMsg);
    LPCTSTR (WINAPI* GetCurrentMail)();
    void    (WINAPI* SetCurrentMail)(LPCTSTR lpMailID);
    int     (WINAPI* GetNextMail)(int nStart, LPSTR lpszMailID, int nBuf, BOOL bSelected);
    void    (WINAPI* SetSel)(LPCTSTR lpMailID, BOOL bSel);
    BOOL    (WINAPI* AppendMessage)(LPCTSTR lpFolderID, LPCTSTR lpszData);
    BOOL    (WINAPI* MoveSelectedMessages)(LPCTSTR lpFolderID, BOOL bCopy);
    DWORD   (WINAPI* GetStatus)(LPCTSTR lpMailID);
    HWND    (WINAPI* ComposeMail)(LPCTSTR lpURL);
    int     (WINAPI* GetCharSet)(LPCTSTR lpMailID, LPSTR lpszCharSet, int nBuf);
    LPSTR   (WINAPI* GetSource)(LPCTSTR lpMailID);
    void    (WINAPI* SetSource)(LPCTSTR lpMailID, LPCTSTR lpSource);
    LPSTR   (WINAPI* GetHeader)(LPCTSTR lpMailID);
    LPSTR   (WINAPI* GetText)(LPSTR lpszMimeType, int nBuf);
    void    (WINAPI* SetText)(int nMode, LPCTSTR lpText);
    void    (WINAPI* GetSpecifiedHeader)(LPCTSTR lpHeader, LPSTR lpszData, int nBuf);
    void    (WINAPI* SetSpecifiedHeader)(LPCTSTR lpHeader, LPCTSTR lpszData);
    int     (WINAPI* CompGetCharSet)(HWND hWnd, LPSTR lpszCharSet, int nBuf);
    LPSTR   (WINAPI* CompGetSource)(HWND hWnd);
    void    (WINAPI* CompSetSource)(HWND hWnd, LPCTSTR lpSource);
    LPSTR   (WINAPI* CompGetHeader)(HWND hWnd);
    void    (WINAPI* CompGetSpecifiedHeader)(HWND hWnd, LPCTSTR lpHeader, LPSTR lpszData, int nBuf);
    void    (WINAPI* CompSetSpecifiedHeader)(HWND hWnd, LPCTSTR lpHeader, LPCTSTR lpszData);
    LPSTR   (WINAPI* CompGetText)(HWND hWnd, LPSTR lpszMimeType, int nBuf);
    void    (WINAPI* CompSetText)(HWND hWnd, int nMode, LPCTSTR lpText);
    void    (WINAPI* CompAttachFile)(HWND hWnd, LPCTSTR lpAttachFile, LPCTSTR lpMimeType);
    LPVOID  (WINAPI* Alloc)(DWORD dwSize);
    LPVOID  (WINAPI* ReAlloc)(LPVOID lpVoid, DWORD dwSize);
    void    (WINAPI* Free)(LPVOID lpVoid);
    LPSTR   (WINAPI* ISO_2022_JP)(LPCTSTR lpSrc, BOOL bEncode);
    LPSTR   (WINAPI* ISO_2022_KR)(LPCTSTR lpSrc, BOOL bEncode);
    LPSTR   (WINAPI* HZ_GB2312)(LPCTSTR lpSrc, BOOL bEncode);
    LPSTR   (WINAPI* ISO_8859_2)(LPCTSTR lpSrc, BOOL bEncode);
    LPSTR   (WINAPI* EUC_JP)(LPCTSTR lpSrc, BOOL bEncode);
    LPSTR   (WINAPI* UTF_7)(LPCTSTR lpSrc, BOOL bEncode);
    LPSTR   (WINAPI* UTF_8)(LPCTSTR lpSrc, BOOL bEncode);
    BOOL    (WINAPI* B64Convert)(LPCTSTR lpszOutFile, LPCTSTR lpszInFile, BOOL bEncode);
    BOOL    (WINAPI* QPConvert)(LPCTSTR lpszOutFile, LPCTSTR lpszInFile, BOOL bEncode);
    LPSTR   (WINAPI* MIMEHeader)(LPCTSTR lpszIn, LPSTR lpszCharSet, int nBuf, BOOL bEncode);
    LPSTR   (WINAPI* SerializeRcpts)(LPCTSTR lpAddresses);
    BOOL    (WINAPI* Connect)(BOOL bConnect);

protected:
    CB2API();
    HINSTANCE m_hInstBecky;

private:
    static CB2API* _instance;
};

