/////////////////////////////////////////////////////////////////////////////////
//
// BkMessage.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: BkMessage.cpp,v $
 * Revision 1.5  2000/08/06 15:14:41  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkMail.h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐BkMail.hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkMail.cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr apEncrypt1;
 *         apEncrypt1 = mail.SetChild(new CMIMEItem());
 *
 * Revision 1.4  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 * Revision 1.3  2000/07/07 14:11:54  syou
 * - ؂Bmultipartȃ[؂ł܂BAʂ{ɕ\
 *   ̂Łccǂł傤H  Ƃ́A؃xwł悤ɂA
 *   ̑OɕȂẮB
 *   CBkMessage::ExploreItemTree̋@\͂܂ӖȂH
 *   CBkMailPGPn̎̂ł͂ȂāA͂class CBkPGPMailh
 *   čׂB
 *   class count_ptrǉČڕGBꂪƂĂȂ܂B
 *   قƂǐŁAclass CEventDataAclass CSignatureDataȂǂǉB
 *
 * Revision 1.1  2000/07/05 23:50:32  murayama-s
 * - ؂̎dg݂͂BƂ͏ڍׂȎdllȂ
 *    ȂBclass CSignatureDataǉB܂l̗]n傫
 *    classB
 *
 * Revision 1.2  2000/07/01 23:48:09  syou
 * - FindMIMEItemFirst()bugfix
 *
 * Revision 1.1  2000/06/29 15:53:11  syou
 * - class CBkMessageAclass CBkMailPartAclass CBkMail
 *   FindMIMEItemFirst()A FindMIMEItemNext()A ExploreItemTree()A
 *   IsMIMEItem()AȂǂȂǎBׂẮAPGPDecodevO
 *   邽߁BJavaCNnewIuWFNg߂悤
 *   ̂ŁAdeleteȂ΂ȂȂԂA
 *   Ȃ߃Ã΃ǃЃуŃʃł́Atemplate class count_ptr
 *   BA͏O̖{Ƃ肾̂Ȃ̂ŁAŐV
 *   ł͂ȂmȂBŔނWeby[WQƂKv邩
 *   ȁBDecoden̎͂ꂩȂ̂ŁA PGPsdk̃TvvO
 *   Ă (^^;  ܂܂ꂩ炾cc
 *
 *
 */


#include "BkMessage.h"


/////////////////////////////////////////////////////////////////////////////////
//
CBkMessage::CBkMessage()
{
    m_pbka = CB2API::Instance();
    m_pItem = NULL;
}


CBkMessage::CBkMessage(const CBkMessage& bm)
{
    m_pbka = bm.m_pbka;
    m_listItem = bm.m_listItem;

    if (bm.m_pItem) {
        LPSTR lpSource = bm.m_pItem->ToString();
        LPSTR lpTemp = lpSource;
        m_pItem->FromString(lpTemp);
        free(lpSource);
    }
}


CBkMessage::~CBkMessage()
{
}


CBkMessage& CBkMessage::operator =(const CBkMessage& bm)
{
    if (this != &bm) {
        m_pbka = bm.m_pbka;
        m_listItem = bm.m_listItem;

        if (bm.m_pItem) {
            LPSTR lpSource = bm.m_pItem->ToString();
            LPSTR lpTemp = lpSource;
            m_pItem->FromString(lpTemp);
            free(lpSource);
        }
    }
    return *this;
}


BOOL CBkMessage::IsMIMEItem(LPCTSTR lpszType, LPCTSTR lpszSubType)
{
    if ((!lpszType || (lpszType && stricmp(lpszType, m_pItem->m_szType) == 0)) &&
        (!lpszSubType || (lpszSubType && stricmp(lpszSubType, m_pItem->m_szSubType) == 0)) ) {
        return TRUE;
    }
    return FALSE;
}


void CBkMessage::ExploreItemTree(LPCTSTR lpszType, LPCTSTR lpszSubType, CMIMEItem* pItem, DWORD dwFlag)
{
    if (pItem == NULL) {
        return;
    }

    if ((!lpszType || (lpszType && stricmp(lpszType, pItem->m_szType) == 0)) &&
        (!lpszSubType || (lpszSubType && stricmp(lpszSubType, pItem->m_szSubType) == 0)) ) {
        m_listItem.push_back(pItem);
    }

    if (dwFlag & FINDMIMEITEM_FIRST_CHILD) {
        CMIMEItem* pMimeItem = pItem->GetChild();
        if (pMimeItem) {
            if (dwFlag & FINDMIMEITEM_FIRST_ONE) {
                dwFlag ^= FINDMIMEITEM_FIRST_CHILD;
            }
            ExploreItemTree(lpszType, lpszSubType, pMimeItem, dwFlag);
        }
        if (dwFlag & FINDMIMEITEM_NEXT) {
            pMimeItem = pItem->GetNext();
            if (pMimeItem) {
                if (dwFlag & FINDMIMEITEM_SECOND_ONE) {
                    dwFlag ^= FINDMIMEITEM_NEXT;
                }
                ExploreItemTree(lpszType, lpszSubType, pMimeItem, dwFlag);
            }
        }
    }
    else if (dwFlag & FINDMIMEITEM_FIRST_NEXT) {
        CMIMEItem* pMimeItem = pItem->GetNext();
        if (pMimeItem) {
            if (dwFlag & FINDMIMEITEM_FIRST_ONE) {
                dwFlag ^= FINDMIMEITEM_FIRST_NEXT;
            }
            ExploreItemTree(lpszType, lpszSubType, pMimeItem, dwFlag);
        }
        if (dwFlag & FINDMIMEITEM_CHILD) {
            pMimeItem = pItem->GetNext();
            if (pMimeItem) {
                if (dwFlag & FINDMIMEITEM_SECOND_ONE) {
                    dwFlag ^= FINDMIMEITEM_CHILD;
                }
                ExploreItemTree(lpszType, lpszSubType, pMimeItem, dwFlag);
            }
        }
    }
}


void CBkMessage::SetContentType(LPCSTR lpHeader, LPCTSTR lpData)
{
	LPSTR lpsz = strdup(lpData);
    if (lpsz == NULL) {
        return;
    }

    free(m_pItem->m_lpBoundary);
    m_pItem->m_lpBoundary = NULL;

    LPSTR lpType = strtok(lpsz, "/ \t");
	LPSTR lpSubType = strtok(NULL, "; \r\n\t");
	if (lpType && lpSubType) {
		strncpy(m_pItem->m_szType, lpType, 40);
        m_pItem->m_szType[40] = '\0';
		strncpy(m_pItem->m_szSubType, lpSubType, 40);
        m_pItem->m_szSubType[40] = '\0';

		LPSTR lpOpt, lpVal;
		LPSTR lpOption = strtok(NULL, "");
		if (lpOption) {
			lpOption = GetOptValue(lpOption, lpOpt, lpVal);
			while (lpOption) {
				if (stricmp(lpOpt, "boundary") == 0) {
                    if (m_pItem->m_lpBoundary) {
                        free(m_pItem->m_lpBoundary);
                    }
					m_pItem->m_lpBoundary = strdup(lpVal);
				}
                if (*lpOption == '\0') {
                    break;
                }
				lpOption = GetOptValue(lpOption, lpOpt, lpVal);
			}
		}
	}
    free(lpsz);
}

